import javax.media.j3d.*;
import javax.vecmath.*;

/* a bounding box for viewing
 *
 * using simple lines
 *
 * written by M. Geroch
 */


public class BBox extends Shape3D{

 


  public BBox(float minx, float maxx, 
	      float miny, float maxy,
	      float minz, float maxz) {
    this.setGeometry(createGeometry(minx, maxx, miny, maxy, minz, maxz));
  }

  public void newSize(float minx, float maxx,
		 float miny, float maxy,
		 float minz, float maxz) {
    this.setGeometry(createGeometry(minx, maxx, miny, maxy, minz, maxz));
  }



  private Geometry createGeometry(float minx, float maxx,
				  float miny, float maxy,
				  float minz, float maxz) {

    // create line array
    LineArray boxLines = new LineArray(24, LineArray.COORDINATES | 
					LineArray.COLOR_3);

    // lines for horizontal box bottom
    boxLines.setCoordinate(0, new Point3f(minx, miny, maxz));
    boxLines.setCoordinate(1, new Point3f(minx, miny, minz));

    boxLines.setCoordinate(2, new Point3f(minx, miny, minz));
    boxLines.setCoordinate(3, new Point3f(maxx, miny, minz));

    boxLines.setCoordinate(4, new Point3f(maxx, miny, minz));
    boxLines.setCoordinate(5, new Point3f(maxx, miny, maxz));

    boxLines.setCoordinate(6, new Point3f(maxx, miny, maxz));
    boxLines.setCoordinate(7, new Point3f(minx, miny, maxz));

    // lines for vertical 
    boxLines.setCoordinate(8, new Point3f(minx, miny, maxz));
    boxLines.setCoordinate(9, new Point3f(minx, maxy, maxz));

    boxLines.setCoordinate(10, new Point3f(minx, miny, minz));
    boxLines.setCoordinate(11, new Point3f(minx, maxy, minz));

    boxLines.setCoordinate(12, new Point3f(maxx, miny, minz));
    boxLines.setCoordinate(13, new Point3f(maxx, maxy, minz));

    boxLines.setCoordinate(14, new Point3f(maxx, miny, maxz));
    boxLines.setCoordinate(15, new Point3f(maxx, maxy, maxz));

    // lines for horizontal box top
    boxLines.setCoordinate(16, new Point3f(minx, maxy, maxz));
    boxLines.setCoordinate(17, new Point3f(minx, maxy, minz));

    boxLines.setCoordinate(18, new Point3f(minx, maxy, minz));
    boxLines.setCoordinate(19, new Point3f(maxx, maxy, minz));

    boxLines.setCoordinate(20, new Point3f(maxx, maxy, minz));
    boxLines.setCoordinate(21, new Point3f(maxx, maxy, maxz));

    boxLines.setCoordinate(22, new Point3f(maxx, maxy, maxz));
    boxLines.setCoordinate(23, new Point3f(minx, maxy, maxz));

    for (int j=0; j < 24; ++j)
      boxLines.setColor(j, ColorConstants.lightgray);

    return boxLines;

  }
}

				       


