import javax.media.j3d.*;
import javax.vecmath.*;

/* a color-coded axis system with
 * red as positive x-axis
 * green as positive y-axis
 * blue as positive z-axis
 * 
 * using simple lines
 *
 * written by M. Geroch
 */


public class GroundPlane extends Shape3D{

 


  public GroundPlane(float Size, float Interval) {
    this.setGeometry(createGeometry(Size, Interval));
  }

  private Geometry createGeometry(float Size, float Interval) {
    
    int numverts = (int)((Size*2.0)/Interval);
    int halflines = numverts+1;
    int numlines = halflines*2;
    numverts = numlines*2;

    // create line array
    LineArray planeLines = new LineArray(numverts, LineArray.COORDINATES | 
					LineArray.COLOR_3);
    float x = -Size; 
    float z = -Size;
    for (int j = 0; j < halflines; ++j) {
      planeLines.setCoordinate(2*j, new Point3f(x, 0.0f, -Size));
      planeLines.setCoordinate(2*j+1, new Point3f(x, 0.0f, Size));
      x += Interval;
    }
    for (int j = halflines; j < numlines; ++j) {
      planeLines.setCoordinate(2*j, new Point3f(-Size, 0.0f, z));
      planeLines.setCoordinate(2*j+1, new Point3f(Size, 0.0f, z));
      z += Interval;
    }

    for (int j = 0; j < numverts; ++j)
      planeLines.setColor(j, ColorConstants.darkgray);
			       
    return planeLines;

  }
}

				       
