import java.awt.*;
import java.awt.event.*;

public class InfoDialog extends Dialog implements ActionListener {
    protected Button button;
    protected MultiLineLabel label;

    public InfoDialog(Frame parent, String title, String message) {
	super(parent, title, false);
	this.setLayout(new BorderLayout(15, 15));
	label = new MultiLineLabel(message, 20, 20);
	this.add("Center", label);

	button = new Button("OK");
	button.addActionListener(this);
	Panel p = new Panel();
	p.setLayout(new FlowLayout(FlowLayout.CENTER, 15, 15));
	p.add(button);
	this.add("South", p);
	this.pack();
    }

    
    public void actionPerformed(ActionEvent e) {
	String cmd = e.getActionCommand();
	if (cmd.equals("OK")) {
	    this.hide();
	    this.dispose();
	}
    }


    public static void main(String[] args) {
	Frame f = new Frame("InfoDialogTest");
	f.setSize(200, 200);
	f.show();
	
	InfoDialog d = new InfoDialog(f, "About",
				      "This demo ...\n" +
				      "... Meg Geroch");
	d.setSize(150, 150);
	d.setLocation(100,100);
	d.show();
    }
}



