//define the structure of the asf structure data
import java.awt.*;
import java.io.*;
import java.util.*;
import java.applet.*;
import java.net.*;
import javax.vecmath.*;
import javax.media.j3d.*;
import java.lang.*;
import java.lang.Math;
//import java.lang.StrictMath;

/* 4x4 matrix class */

public class Matrix
{
  float mat[][];
  double DEGTORAD;

  Matrix ()
    {
	  mat = new float[4][4];
      makeIdent();
	  DEGTORAD = 1*Math.PI/180.0;
    }

  Matrix (float m00, float m01, float m02, float m03,
		 float m10, float m11, float m12, float m13,
		 float m20, float m21, float m22, float m23,
		 float m30, float m31, float m32, float m33)
    {
	  DEGTORAD = 1*Math.PI/180.0;
	  mat = new float[4][4];
      mat[0][0] = m00; mat[0][1] = m01; mat[0][2] = m02; mat[0][3] = m03; 
      mat[1][0] = m10; mat[1][1] = m11; mat[1][2] = m12; mat[1][3] = m13; 
      mat[2][0] = m20; mat[2][1] = m21; mat[2][2] = m22; mat[2][3] = m23; 
      mat[3][0] = m30; mat[3][1] = m31; mat[3][2] = m32; mat[3][3] = m33; 
    };

  public void makeIdent ()
    {
      mat[0][0] = 1.0f; mat[0][1] = 0.0f; mat[0][2] = 0.0f; mat[0][3] = 0.0f; 
      mat[1][0] = 0.0f; mat[1][1] = 1.0f; mat[1][2] = 0.0f; mat[1][3] = 0.0f; 
      mat[2][0] = 0.0f; mat[2][1] = 0.0f; mat[2][2] = 1.0f; mat[2][3] = 0.0f; 
      mat[3][0] = 0.0f; mat[3][1] = 0.0f; mat[3][2] = 0.0f; mat[3][3] = 1.0f; 
    };

  public void postTrans (float x, float y, float z)
    {
	  float mmat[][] = new float[4][4];
	  int i,j;

	  for(i=0;i<4;i++)
	    for(j=0;j<4;j++)
		{
			mmat[i][j] = mat[i][j];
		};

      mat[0][0] = mmat[0][0]+mmat[0][3]*x;
      mat[0][1] = mmat[0][1]+mmat[0][3]*y;
      mat[0][2] = mmat[0][2]+mmat[0][3]*z;
      mat[0][3] = mmat[0][3];

      mat[1][0] = mmat[1][0]+mmat[1][3]*x;
      mat[1][1] = mmat[1][1]+mmat[1][3]*y;
      mat[1][2] = mmat[1][2]+mmat[1][3]*z;
      mat[1][3] = mmat[1][3];

      mat[2][0] = mmat[2][0]+mmat[2][3]*x;
      mat[2][1] = mmat[2][1]+mmat[2][3]*y;
      mat[2][2] = mmat[2][2]+mmat[2][3]*z;
      mat[2][3] = mmat[2][3];

      mat[3][0] = mmat[3][0]+mmat[3][3]*x;
      mat[3][1] = mmat[3][1]+mmat[3][3]*y;
      mat[3][2] = mmat[3][2]+mmat[3][3]*z;
      mat[3][3] = mmat[3][3];
    };


  public void postRotX (float deg)
    {
	  float mmat[][] = new float[4][4];
	  int i,j;

	  for(i=0;i<4;i++)
	    for(j=0;j<4;j++)
		{
			mmat[i][j] = mat[i][j];
		};
      float C = (float)Math.cos((double)deg*DEGTORAD);
      float S = (float)Math.sin((double)deg*DEGTORAD);

      mat[0][0] = mmat[0][0];
      mat[0][1] = mmat[0][1]*C - mmat[0][2]*S;
      mat[0][2] = mmat[0][1]*S + mmat[0][2]*C;
      mat[0][3] = mmat[0][3];

      mat[1][0] = mmat[1][0];
      mat[1][1] = mmat[1][1]*C - mmat[1][2]*S;
      mat[1][2] = mmat[1][1]*S + mmat[1][2]*C;
      mat[1][3] = mmat[1][3];

      mat[2][0] = mmat[2][0];
      mat[2][1] = mmat[2][1]*C - mmat[2][2]*S;
      mat[2][2] = mmat[2][1]*S + mmat[2][2]*C;
      mat[2][3] = mmat[2][3];

      mat[3][0] = mmat[3][0];
      mat[3][1] = mmat[3][1]*C - mmat[3][2]*S;
      mat[3][2] = mmat[3][1]*S + mmat[3][2]*C;
      mat[3][3] = mmat[3][3];
    }


  public void postRotY (float deg)
    {
	  float mmat[][] = new float[4][4];
	  int i,j;

	  for(i=0;i<4;i++)
	    for(j=0;j<4;j++)
		{
			mmat[i][j] = mat[i][j];
		};
      float C = (float)Math.cos((double)deg*DEGTORAD);
      float S = (float)Math.sin((double)deg*DEGTORAD);

      mat[0][0] = mmat[0][0]*C + mmat[0][2]*S;
      mat[0][1] = mmat[0][1];
      mat[0][2] = mmat[0][2]*C - mmat[0][0]*S;
      mat[0][3] = mmat[0][3];

      mat[1][0] = mmat[1][0]*C + mmat[1][2]*S;
      mat[1][1] = mmat[1][1];
      mat[1][2] = mmat[1][2]*C - mmat[1][0]*S;
      mat[1][3] = mmat[1][3];

      mat[2][0] = mmat[2][0]*C + mmat[2][2]*S;
      mat[2][1] = mmat[2][1];
      mat[2][2] = mmat[2][2]*C - mmat[2][0]*S;
      mat[2][3] = mmat[2][3];

      mat[3][0] = mmat[3][0]*C + mmat[3][2]*S;
      mat[3][1] = mmat[3][1];
      mat[3][2] = mmat[3][2]*C - mmat[3][0]*S;
      mat[3][3] = mmat[3][3];
    }


  public void postRotZ (float deg)
    {
	  float mmat[][] = new float[4][4];
	  int i,j;

	  for(i=0;i<4;i++)
	    for(j=0;j<4;j++)
		{
			mmat[i][j] = mat[i][j];
		};
      float C = (float)Math.cos((double)deg*DEGTORAD);
      float S = (float)Math.sin((double)deg*DEGTORAD);

      mat[0][0] = mmat[0][0]*C - mmat[0][1]*S;
      mat[0][1] = mmat[0][0]*S + mmat[0][1]*C;
      mat[0][2] = mmat[0][2];
      mat[0][3] = mmat[0][3];

      mat[1][0] = mmat[1][0]*C - mmat[1][1]*S;
      mat[1][1] = mmat[1][0]*S + mmat[1][1]*C;
      mat[1][2] = mmat[1][2];
      mat[1][3] = mmat[1][3];

      mat[2][0] = mmat[2][0]*C - mmat[2][1]*S;
      mat[2][1] = mmat[2][0]*S + mmat[2][1]*C;
      mat[2][2] = mmat[2][2];
      mat[2][3] = mmat[2][3];

      mat[3][0] = mmat[3][0]*C - mmat[3][1]*S;
      mat[3][1] = mmat[3][0]*S + mmat[3][1]*C;
      mat[3][2] = mmat[3][2];
      mat[3][3] = mmat[3][3];
    }

  public void postMult (Matrix m)
    {
      float r[][]=new float[4][4];

      r[0][0] =
	mat[0][0]*m.mat[0][0]+mat[0][1]*m.mat[1][0]+mat[0][2]*m.mat[2][0]+mat[0][3]*m.mat[3][0];

      r[0][1] =
	mat[0][0]*m.mat[0][1]+mat[0][1]*m.mat[1][1]+mat[0][2]*m.mat[2][1]+mat[0][3]*m.mat[3][1];

      r[0][2] =
	mat[0][0]*m.mat[0][2]+mat[0][1]*m.mat[1][2]+mat[0][2]*m.mat[2][2]+mat[0][3]*m.mat[3][2];

      r[0][3] =
	mat[0][0]*m.mat[0][3]+mat[0][1]*m.mat[1][3]+mat[0][2]*m.mat[2][3]+mat[0][3]*m.mat[3][3];

      r[1][0] =
	mat[1][0]*m.mat[0][0]+mat[1][1]*m.mat[1][0]+mat[1][2]*m.mat[2][0]+mat[1][3]*m.mat[3][0];

      r[1][1] =
	mat[1][0]*m.mat[0][1]+mat[1][1]*m.mat[1][1]+mat[1][2]*m.mat[2][1]+mat[1][3]*m.mat[3][1];

      r[1][2] =
	mat[1][0]*m.mat[0][2]+mat[1][1]*m.mat[1][2]+mat[1][2]*m.mat[2][2]+mat[1][3]*m.mat[3][2];

      r[1][3] =
	mat[1][0]*m.mat[0][3]+mat[1][1]*m.mat[1][3]+mat[1][2]*m.mat[2][3]+mat[1][3]*m.mat[3][3];

      r[2][0] =
	mat[2][0]*m.mat[0][0]+mat[2][1]*m.mat[1][0]+mat[2][2]*m.mat[2][0]+mat[2][3]*m.mat[3][0];

      r[2][1] =
	mat[2][0]*m.mat[0][1]+mat[2][1]*m.mat[1][1]+mat[2][2]*m.mat[2][1]+mat[2][3]*m.mat[3][1];

      r[2][2] =
	mat[2][0]*m.mat[0][2]+mat[2][1]*m.mat[1][2]+mat[2][2]*m.mat[2][2]+mat[2][3]*m.mat[3][2];

      r[2][3] =
	mat[2][0]*m.mat[0][3]+mat[2][1]*m.mat[1][3]+mat[2][2]*m.mat[2][3]+mat[2][3]*m.mat[3][3];

      r[3][0] =
	mat[3][0]*m.mat[0][0]+mat[3][1]*m.mat[1][0]+mat[3][2]*m.mat[2][0]+mat[3][3]*m.mat[3][0];

      r[3][1] =
	mat[3][0]*m.mat[0][1]+mat[3][1]*m.mat[1][1]+mat[3][2]*m.mat[2][1]+mat[3][3]*m.mat[3][1];

      r[3][2] =
	mat[3][0]*m.mat[0][2]+mat[3][1]*m.mat[1][2]+mat[3][2]*m.mat[2][2]+mat[3][3]*m.mat[3][2];

      r[3][3] =
	mat[3][0]*m.mat[0][3]+mat[3][1]*m.mat[1][3]+mat[3][2]*m.mat[2][3]+mat[3][3]*m.mat[3][3];

      int i,j;
	  for(i=0;i<4;i++)
	     for(j=0;j<4;j++)
		   mat[i][j]=r[i][j];
    }

    public float[] xformPt (float[] v)
    {
	  float res[] = new float[3];
      res[0] = v[0]*mat[0][0] + v[1]*mat[1][0] + v[2]*mat[2][0] + mat[3][0];
      res[1] = v[0]*mat[0][1] + v[1]*mat[1][1] + v[2]*mat[2][1] + mat[3][1];
      res[2] = v[0]*mat[0][2] + v[1]*mat[1][2] + v[2]*mat[2][2] + mat[3][2];
	  return res;
    }

    public float[] xformPt4f (float[] v)
    {
	  float res[] = new float[4];
      res[0] = v[0]*mat[0][0] + v[1]*mat[1][0] + v[2]*mat[2][0] + mat[3][0]*v[3];
      res[1] = v[0]*mat[0][1] + v[1]*mat[1][1] + v[2]*mat[2][1] + mat[3][1]*v[3];
      res[2] = v[0]*mat[0][2] + v[1]*mat[1][2] + v[2]*mat[2][2] + mat[3][2]*v[3];
	  res[3] = v[0]*mat[0][3] + v[1]*mat[1][3] + v[2]*mat[2][3] + mat[3][3]*v[3];
	  res[0] = res[0]/res[3];
	  res[1] = res[1]/res[3];
	  res[2] = res[2]/res[3];
	  return res;
    }

	public void invert ()
    {
      float det;
      float a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p;

      a = mat[0][0]; b = mat[1][0]; c = mat[2][0]; d = mat[3][0];
      e = mat[0][1]; f = mat[1][1]; g = mat[2][1]; h = mat[3][1];
      i = mat[0][2]; j = mat[1][2]; k = mat[2][2]; l = mat[3][2];
      m = mat[0][3]; n = mat[1][3]; o = mat[2][3]; p = mat[3][3];

      det = d*g*j*m - c*h*j*m - d*f*k*m + b*h*k*m + c*f*l*m -
	b*g*l*m - d*g*i*n + c*h*i*n + d*e*k*n - a*h*k*n -
	c*e*l*n + a*g*l*n + d*f*i*o - b*h*i*o - d*e*j*o +
	a*h*j*o + b*e*l*o - a*f*l*o - c*f*i*p + b*g*i*p +
	c*e*j*p - a*g*j*p - b*e*k*p + a*f*k*p;
  
      if (det == 0)
	{
	  return;
	}

      det = 1.0f / det;

      mat[0][0] = (-(h*k*n) + g*l*n + h*j*o - f*l*o - g*j*p + f*k*p) * det;
      mat[1][0] = (d*k*n - c*l*n - d*j*o + b*l*o + c*j*p - b*k*p) * det;
      mat[2][0] = (-(d*g*n) + c*h*n + d*f*o - b*h*o - c*f*p + b*g*p) * det;
      mat[3][0] = (d*g*j - c*h*j - d*f*k + b*h*k + c*f*l - b*g*l) * det;
      mat[0][1] = (h*k*m - g*l*m - h*i*o + e*l*o + g*i*p - e*k*p) * det;
      mat[1][1] = (-(d*k*m) + c*l*m + d*i*o - a*l*o - c*i*p + a*k*p) * det;
      mat[2][1] = (d*g*m - c*h*m - d*e*o + a*h*o + c*e*p - a*g*p) * det;
      mat[3][1] = (-(d*g*i) + c*h*i + d*e*k - a*h*k - c*e*l + a*g*l) * det;
      mat[0][2] = (-(h*j*m) + f*l*m + h*i*n - e*l*n - f*i*p + e*j*p) * det;
      mat[1][2] = (d*j*m - b*l*m - d*i*n + a*l*n + b*i*p - a*j*p) * det;
      mat[2][2] = (-(d*f*m) + b*h*m + d*e*n - a*h*n - b*e*p + a*f*p) * det;
      mat[3][2] = (d*f*i - b*h*i - d*e*j + a*h*j + b*e*l - a*f*l) * det;
      mat[0][3] = (g*j*m - f*k*m - g*i*n + e*k*n + f*i*o - e*j*o) * det;
      mat[1][3] = (-(c*j*m) + b*k*m + c*i*n - a*k*n - b*i*o + a*j*o) * det;
      mat[2][3] = (c*f*m - b*g*m - c*e*n + a*g*n + b*e*o - a*f*o) * det;
      mat[3][3] = (-(c*f*i) + b*g*i + c*e*j - a*g*j - b*e*k + a*f*k) * det;

      return;
    }

	public static void main(String args[]) throws Exception {
	Matrix mat = new Matrix();
	mat.postRotZ(45.0f);
	mat.postRotX(30.0f);
	String output = Float.toString(mat.mat[0][0]);
	output=output+' '+Float.toString(mat.mat[0][1]);
	output=output+' '+Float.toString(mat.mat[0][2]);
	output=output+' '+Float.toString(mat.mat[0][3]);
	System.out.println(output);

	output = Float.toString(mat.mat[1][0]);
	output=output+' '+Float.toString(mat.mat[1][1]);
	output=output+' '+Float.toString(mat.mat[1][2]);
	output=output+' '+Float.toString(mat.mat[1][3]);
	System.out.println(output);

	output = Float.toString(mat.mat[2][0]);
	output=output+' '+Float.toString(mat.mat[2][1]);
	output=output+' '+Float.toString(mat.mat[2][2]);
	output=output+' '+Float.toString(mat.mat[2][3]);
	System.out.println(output);

	output = Float.toString(mat.mat[3][0]);
	output=output+' '+Float.toString(mat.mat[3][1]);
	output=output+' '+Float.toString(mat.mat[3][2]);
	output=output+' '+Float.toString(mat.mat[3][3]);
	System.out.println(output);


    }
}


