import javax.media.j3d.*;
import javax.vecmath.*;

/* a color-coded axis system with
 * red as positive x-axis
 * green as positive y-axis
 * blue as positive z-axis
 * 
 * using simple lines
 *
 * written by M. Geroch
 */


public class jointslon extends Shape3D{

  public jointslon(asf_struct joints[],int number_joints,boolean app[]) {
    this.setGeometry(createGeometry(joints,number_joints,app));
	PointAttributes pa = new PointAttributes(4.0f,true);
	Appearance appe= new Appearance();
	appe.setPointAttributes(pa);
	this.setAppearance(appe);
  }


  private Geometry createGeometry(asf_struct joints[],int number_joints,boolean app[]) {
    
    int numlines = number_joints-1;
	int count = 0;
	int i,j;
    
    for(i=0;i<number_joints;i++)
	  if(app[i])count++;
    // create line array
    PointArray points = new PointArray(count, PointArray.COORDINATES | 
					PointArray.COLOR_3);
	count=0;
    for (j = 0; j < number_joints; j++) {
	     if(app[j])
		 {
			points.setCoordinate(count, new Point3f(joints[j].ab_pos[0], joints[j].ab_pos[1], joints[j].ab_pos[2]));
			count++;
		 }
    }
	System.out.println(count);
    for (j = 0; j < count; j++)
	{
      points.setColor(j, ColorConstants.yellow);
	}
			       
    return points;

  }


  public jointslon(asf_struct joints[],int number_joints,int frame,boolean app[]) {
    this.setGeometry(createGeometry(joints,number_joints,frame,app));
	PointAttributes pa = new PointAttributes(4.0f,true);
	Appearance appe= new Appearance();
	appe.setPointAttributes(pa);
	this.setAppearance(appe);
  }

  /*public skeleton(asf_struct joints[],int number_joints,int frame,boolean app[]) {
    this.setGeometry(createGeometry(joints,number_joints,frame,app));
  }*/
  private Geometry createGeometry(asf_struct joints[],int number_joints,int frame,boolean app[]) {
    
    int numlines = number_joints-1;
	int count = 0;
	int i,j;
    
    for(i=0;i<number_joints;i++)
	  if(app[i])count++;
    // create line array
    PointArray points = new PointArray(count, PointArray.COORDINATES | 
					PointArray.COLOR_3);
    count=0;
    for (j = 0; j < number_joints; j++) {
	  	 if(app[j])
		 {
		 points.setCoordinate(count, new Point3f(joints[j].amc_position[frame][0], joints[j].amc_position[frame][1], joints[j].amc_position[frame][2]));
         count++;
		 }
	  }
    for (j = 0; j < count; j++)
	{
      points.setColor(j, ColorConstants.yellow);
	}
			       
    return points;

  }
}