import javax.media.j3d.*;
import javax.vecmath.*;

/* a color-coded axis system with
 * red as positive x-axis
 * green as positive y-axis
 * blue as positive z-axis
 * 
 * using simple lines
 *
 * written by M. Geroch
 */


public class skeleton_s extends Shape3D{

  public skeleton_s(asf_struct joints[],int number_joints,boolean app[]) {
    this.setGeometry(createGeometry(joints,number_joints,app));
  }

  public skeleton_s(asf_struct joints[],int number_joints,boolean app[],int linknet[][]) {
    this.setGeometry(createGeometry(joints,number_joints,app,linknet));
  }

  public skeleton_s(asf_struct joints[],int number_joints,int frame,boolean app[]) {
    this.setGeometry(createGeometry(joints,number_joints,frame,app));
  }


  private Geometry createGeometry(asf_struct joints[],int number_joints,boolean app[]) {
    
    int numlines = number_joints-1;
	int count = 0;
	int i,j;
    

    // create line array
	
    LineArray planeLines = new LineArray(2*numlines, LineArray.COORDINATES | 
					LineArray.COLOR_3);
    for (j = 0; j < number_joints; j++) {
	  for(i=0;i<joints[j].number_son;i++)
	  {
	     if(app[j] && app[joints[j].sons[i]])
		 {
			planeLines.setCoordinate(2*count, new Point3f(joints[j].ab_pos[0], joints[j].ab_pos[1], joints[j].ab_pos[2]));
			planeLines.setCoordinate(2*count+1, new Point3f(joints[joints[j].sons[i]].ab_pos[0], joints[joints[j].sons[i]].ab_pos[1],joints[joints[j].sons[i]].ab_pos[2]));	
			count++;
		 }
	  }
    }
	System.out.println(numlines);
	System.out.println(count);
    for (j = 0; j < 2*numlines; j++)
	{
      planeLines.setColor(j, ColorConstants.yellow);
	}
			       
    return planeLines;

  }

  
  private Geometry createGeometry(asf_struct joints[],int number_joints,int frame,boolean app[]) {
    
    int numlines = number_joints-1;
	int count = 0;
	int i,j;
    

    // create line array
    LineArray planeLines = new LineArray(2*numlines, LineArray.COORDINATES | 
					LineArray.COLOR_3);
    for (j = 0; j < number_joints; j++) {
	  for(i=0;i<joints[j].number_son;i++)
	  {
	     //System.out.println(joints[j].amc_position[frame][0]);
		 if(app[j] && app[joints[j].sons[i]])
		 {
		 planeLines.setCoordinate(2*count, new Point3f(joints[j].amc_position[frame][0], joints[j].amc_position[frame][1], joints[j].amc_position[frame][2]));
         planeLines.setCoordinate(2*count+1, new Point3f(joints[joints[j].sons[i]].amc_position[frame][0], joints[joints[j].sons[i]].amc_position[frame][1],joints[joints[j].sons[i]].amc_position[frame][2]));	
		 count++;
		 }
	  }
    }
	//System.out.println(numlines);
	//System.out.println(count);
    for (j = 0; j < 2*count; j++)
	{
      planeLines.setColor(j, ColorConstants.yellow);
	}
			       
    return planeLines;

  }
  public skeleton_s(asf_struct joints[],int number_joints,int frame,boolean app[],int linknet[][]) {
    this.setGeometry(createGeometry(joints,number_joints,frame,app,linknet));
  }
  private Geometry createGeometry(asf_struct joints[],int number_joints,int frame,boolean app[],int linknet[][]) {
    
    int numlines = number_joints-1;
	int count = 0;
	int i,j;
    for(i=0;i<number_joints;i++)
	{
		for(j=0;j<number_joints-1;j++)
			if(linknet[i][j]!=-1)count++;
	}

    // create line array
	if(count==0)return null;
    LineArray planeLines = new LineArray(2*count, LineArray.COORDINATES | 
					LineArray.COLOR_3);
	count=0;
    for (i = 0; i < number_joints; i++) {
	  for(j=0;j<number_joints-1;j++)
	  {
	     if(linknet[i][j]!=-1)
		 {
		 planeLines.setCoordinate(2*count, new Point3f(joints[i].amc_position[frame][0], joints[i].amc_position[frame][1], joints[i].amc_position[frame][2]));
         planeLines.setCoordinate(2*count+1, new Point3f(joints[linknet[i][j]].amc_position[frame][0], joints[linknet[i][j]].amc_position[frame][1],joints[linknet[i][j]].amc_position[frame][2]));	
		 count++;
		 }
	  }
    }
	for (j = 0; j < 2*count; j++)
	{
      planeLines.setColor(j, ColorConstants.yellow);
	}
			       
    return planeLines;

  }

  private Geometry createGeometry(asf_struct joints[],int number_joints,boolean app[],int linknet[][]) {
    
    int numlines = number_joints-1;
	int count = 0;
	int i,j;
    for(i=0;i<number_joints;i++)
	{
		for(j=0;j<number_joints-1;j++)
			if(linknet[i][j]!=-1)count++;
	}
	// create line array
	if(count==0)
	return null;
    LineArray planeLines = new LineArray(2*count, LineArray.COORDINATES | 
					LineArray.COLOR_3);
	count=0;
    for (i = 0; i < number_joints; i++) {
	  for(j=0;j<number_joints-1;j++)
	  {
	     if(linknet[i][j]!=-1)
		 {
		 planeLines.setCoordinate(2*count, new Point3f(joints[i].ab_pos[0], joints[i].ab_pos[1], joints[i].ab_pos[2]));
         planeLines.setCoordinate(2*count+1, new Point3f(joints[linknet[i][j]].ab_pos[0], joints[linknet[i][j]].ab_pos[1],joints[linknet[i][j]].ab_pos[2]));	
		 count++;
		 }
	  }
    }
	for (j = 0; j < 2*count; j++)
	{
      planeLines.setColor(j, ColorConstants.yellow);
	}
			       
    return planeLines;

  }
}